//  2005 The Weather Channel Interactive, Inc.  All Rights Reserved.

var DEBUGFLAG = false;
var DEBUGPANELLOADED = false;
var DEBUGLEVEL = 0;
var ERRORLOG = Array();
const MAXERRORLOG = 250;

jsInclude("chrome://1clickweather/content/js/buildinfo.js");

function debug(msg){
   if(DEBUGFLAG){
      alert('DEBUG: ' + msg);
   }
}

function createDebugPanel(){
      var p = document.createElement("statusbarpanel");
      p.setAttribute("id", "debugpanel");
      p.setAttribute("collapsed", false);
      document.getElementById('status-bar').appendChild(p);

      var h = document.createElement("hbox");
      p.appendChild(h);

      var l = new oXUL.Label(h, "DEBUG:");
      l.onClick("debugOn();");
      l.Make();

      var l = new oXUL.Label(h, "D");
      l.onClick("debugDisablePopups();");
      l.Make();

      var l = new oXUL.Label(h, "S");
      l.onClick("debugScheduler();");
      l.Tooltip("scheduler");
      l.Make();

      var l = new oXUL.Label(h, "P");
      l.onClick("debugPanels();");
      l.Tooltip("panels");
      l.Make();

      var l = new oXUL.Label(h, "A");
      l.onClick("debugAppConfig();");
      l.Tooltip("app config");
      l.Make();

      var l = new oXUL.Label(h, "T");
      l.onClick("debugTimes();");
      l.Tooltip("times: init " + GlobalInitTime);
      l.Make();

      var l = new oXUL.Label(h, "U");
      l.onClick("debugUserConfig();");
      l.Tooltip("user config");
      l.Make();

      var l = new oXUL.Label(h, "L");
      l.onClick("debugLogShow();");
      l.Tooltip("log");
      l.Make();

      var l = new oXUL.Label(h, "A");
      l.onClick("debugData();");
      l.Tooltip("auto data");
      l.Make();

      DEBUGPANELLOADED = true;
}

function debugOn(){
   DEBUGFLAG = true;
   if(DEBUGLEVEL >= 5){
      DEBUGLEVEL = 0;
      DEBUGFLAG = false;
      alert("Disabling debugging");
      document.getElementById("debugpanel").setAttribute("collapsed", true);
   }else{
      alert("Debugging enabled, level: " + DEBUGLEVEL);
      DEBUGLEVEL++;
   }
}

function debugScheduler(){
   var str = '';
   for(var i in DataContainers){
      str += i + '.Interval = ' + DataContainers[i].Interval + "\n";
      str += i + '.lastUpdate = ' + DataContainers[i].lastUpdate + "\n";
      str += i + '.nextUpdate = ' + DataContainers[i].nextUpdate + "\n";
      str += "\n";
   }

   debugOpenWindow(str);
}

function debugPanels(){
   var str = '';
   for(var i in ToolbarContainers){
      str += ToolbarContainers[i].Dump(true) + "\n\n";
   }
   debugOpenWindow(str);
}

function debugData(){
   for(var i in DataContainers){
      debugOpenWindow(DataContainers[i].Dump(true));
   }
}

function debugLogShow(){
   var str = "LOG: " + GlobalInitTime + "\n";
   for(var i = 0; i < ERRORLOG.length; i++){
      str += ERRORLOG[i] + "\n";
   }
   debugOpenWindow(str);
}

function debugTimes(){
   var str = 'Times:\n';
   str += buildInfo() + "\n";
   str += "startup time: " + GlobalInitTime + "\n";
   debugOpenWindow(str);
}

function debugLog(msg){
   if(msg){
      if(ERRORLOG.length >= MAXERRORLOG){
         ERRORLOG.shift();
      }
      ERRORLOG.push("[" + now() + "] " + msg);
   }
}

function formatXML(str){
   str = str.replace(/>/g, '&gt;\n');
   str = str.replace(/<\//g, '\n&lt;/');
   str = str.replace(/</g, '&lt;');
   return(str);
}
function debugUserConfig(){
   debugOpenWindow(formatXML(GlobalUserConfig.toXMLString()));
}

function debugAppConfig(){
   debugOpenWindow(formatXML(GlobalAppConfig.toXMLString()));
}

function debugOpenWindow(str){
   try{
      var win = window.open("", null, "height=400,width=600,status=no,toolbar=no,menubar=now,location=no,resizable=yes");
      win.document.open();
      win.document.write("<html><body><pre>\n");
      win.document.write(str);
      win.document.write("</pre></body></html>\n");
      win.document.close();
   }catch(e){
      alert(e);
   }
}

function debugDisablePopups(){
   alert("forced popups disabled");
   GlobalDisablePopup = true;
}

