//  2005 The Weather Channel Interactive, Inc.  All Rights Reserved.

function oErrorHandler(){
//   this.id = ToolbarContainers['Options'].getID();
   this.id = "statusbar-container.Options.Tooltip";
   this.Tooltip = null; 
   this.Box = null;
   this.timeout = 30;

   var DebugErrors = true;
   var DebugUI = false;

   // first, we make a tooltip object
   this.Tooltip = document.createElement("tooltip");
   this.Tooltip.setAttribute("id", this.id);
   this.Tooltip.setAttribute("noautohide", false);
   this.Tooltip.setAttribute("class", "ttTooltip");
   this.Tooltip.setAttribute("onmouseover", "GlobalError.Hide()");

   if(DebugUI)
      this.Tooltip.setAttribute("debug", "true");

   this.Box = document.createElement("vbox");
   this.Box.setAttribute("id", this.id + ".box");
   this.Box.setAttribute("height", 200);
   this.Box.setAttribute("width", 200);
   this.Tooltip.appendChild(this.Box);

   document.getElementById("status-bar").appendChild(this.Tooltip);

   this.SwitchBoxs = function(newBox){
      try{
         document.getElementById(this.id).removeChild(this.Box);

         this.Box = newBox;
      }
      catch(e){
         alert("draw: " + e.message);
      }

      document.getElementById(this.id).appendChild(this.Box);
      try{
         var xy = this.locateTooltip();
         this.Tooltip.showPopup(document.getElementById(ToolbarContainers['Options'].getID()), xy[0], xy[1], "tooltip", -1, -1);
      }catch(e){
         alert("s: " + e);
      }
      setTimeout(hideGlobalError, (this.timeout*1000));
   }
   
   function hideGlobalError(){
	GlobalError.Hide();
   }

   this.Show = function(){
      try{
         var newBox = document.createElement("vbox");
         newBox.setAttribute("class", "ttBody");
         this.newHeader(newBox);
         this.newGeneric(newBox);
         this.newFooter(newBox);
         this.SwitchBoxs(newBox);
      }catch(e){
         alert(e);
      }
   }

   this.Hide = function(){
      this.Tooltip.hidePopup();
   }

   this.Network = function(msg){
      var newBox = document.createElement("vbox");
      newBox.setAttribute("width", 200);
      newBox.setAttribute("class", "ttBody");
      this.newHeader(newBox);
      XULSimple.Label(newBox, "A network error has occured:");
      XULSimple.Spacer(newBox, 5);

      var desc = document.createElement("description");
      desc.setAttribute("class", "ttBody");
      desc.setAttribute("width", 200);
      var bodyText = document.createTextNode(msg);
      desc.appendChild(bodyText);
      newBox.appendChild(desc);

      XULSimple.Spacer(newBox, 10);
      this.newFooter(newBox);
      this.SwitchBoxs(newBox);
   }
   
   this.Custom = function(msg){
      var newBox = document.createElement("vbox");
      newBox.setAttribute("class", "ttBody");
      this.newHeader(newBox);
      XULSimple.Label(newBox, msg);
      XULSimple.Spacer(newBox, 10);
      this.newFooter(newBox);
      this.SwitchBoxs(newBox);
   }

   this.newGeneric = function(Box){
      Box.setAttribute("class", "ttBody");
      var topBox = document.createElement("vbox");
      Box.appendChild(topBox);
      var middleBox = document.createElement("vbox");
      Box.appendChild(middleBox);
      var bottomBox = document.createElement("vbox");
      bottomBox.setAttribute("class", "ttBodyBottom");
      Box.appendChild(bottomBox);

      var bodyBox = document.createElement("hbox");
      middleBox.appendChild(bodyBox);

      ////////////////////////////////////////////
      var l = new oXUL.Label(topBox, "Notice: The 1-ClickWeather feed is currently unavailable.");
      l.setClass("ttRedLabel");
      l.Make();

      XULSimple.Spacer(topBox, 10);
      var l = new oXUL.Label(topBox, "This is caused by 1 of 2 conditions:");
      l.setClass("ttBold");
      l.Make();

      ///////////////////////////////////////////

      XULSimple.Spacer(bodyBox, 10);
      var bodyVbox = document.createElement("vbox");
      bodyBox.appendChild(bodyVbox);

      XULSimple.Label(bodyVbox, "you are either browsing offline or");
      XULSimple.Label(bodyVbox, "we are experiencing a temporary outage.");
      XULSimple.Spacer(bodyBox, 10);


      ////////////////////////////////////////////
      XULSimple.Label(bottomBox, "Once internet connectivity to the 1-ClickWeather feed is restored,");
      XULSimple.Label(bottomBox, "you will be presented with current weather data for your area.");
      XULSimple.Spacer(bottomBox, 20);
      XULSimple.Label(bottomBox, "Thank you.");
      XULSimple.Shim(bottomBox, 20, 20);

   }


   this.newHeader = function(Box){
      Box.setAttribute("class", "ttBody");
      var topBox = document.createElement("vbox");
      Box.appendChild(topBox);
      XULSimple.Shim(topBox, 200, 10, "ttBody");

   }


   this.newFooter = function(Box){
      XULSimple.Shim(Box, 5, 5, "ttLogoBody");
      var logoBox = document.createElement("hbox");
//      logoBox.setAttribute("width", 40);
      Box.appendChild(logoBox);
      ////////////////////////////////////////////
//      XULSimple.Spacer(logoBox, 5);

      logoBox.setAttribute("class", "ttLogoBody");
      var i = new oXUL.iconByID(logoBox, "footerlogoleft").Make();
      XULSimple.Shim(logoBox, 180, 10);
      var i = new oXUL.iconByID(logoBox, "footerlogoright").Make();

   }

   this.locateTooltip = function(){
      try{
         var newXY = Array();
         var xy = ToolbarContainers['Day4'].getScreenXY();

         newXY[0] = xy[0] - this.Box.width;
         if(xy[1] < this.Box.height){
            newXY[1] = xy[1];
         }else{
            newXY[1] = xy[1] - this.Box.height;
         }
        
         return(newXY);
      }catch(e){ alert("err: " + e); }

      return(Array(-1, -1));
   }
}

/////////////////////////////////////////////////


function oNetworkErrorHandler(){
   this.id = "statusbar-container.NetworkError.Tooltip";
   this.Tooltip = null; 
   this.Box = null;
   this.timeout = 30;


   // first, we make a tooltip object
   this.Tooltip = document.createElement("tooltip");
   this.Tooltip.setAttribute("id", this.id);
   this.Tooltip.setAttribute("noautohide", false);
   this.Tooltip.setAttribute("class", "ttTooltip");
   this.Tooltip.setAttribute("onmouseover", "GlobalNetworkError.Hide()");


   this.Box = document.createElement("vbox");
   this.Box.setAttribute("id", this.id + ".box");
   this.Box.setAttribute("height", 200);
   this.Box.setAttribute("width", 200);
   this.Tooltip.appendChild(this.Box);

   document.getElementById("status-bar").appendChild(this.Tooltip);

   this.SwitchBoxs = function(newBox){
      try{
         document.getElementById(this.id).removeChild(this.Box);

         this.Box = newBox;
      }
      catch(e){
         alert("draw: " + e.message);
      }

      document.getElementById(this.id).appendChild(this.Box);
      try{
         var xy = this.locateTooltip();
         this.Tooltip.showPopup(document.getElementById(ToolbarContainers['Options'].getID()), xy[0], xy[1], "tooltip", -1, -1);
      }catch(e){
         alert("s: " + e);
      }
      setTimeout(hideGlobalNetworkError, (this.timeout*1000));
   }
   
   function hideGlobalNetworkError(){
		GlobalNetworkError.Hide();
   }

   this.Show = function(){
      try{
         var newBox = document.createElement("vbox");
         newBox.setAttribute("class", "ttBody");
         this.newHeader(newBox);
         this.newGeneric(newBox);
         this.newFooter(newBox);
         this.SwitchBoxs(newBox);
      }catch(e){
         alert(e);
      }
   }

   this.Hide = function(){
      this.Tooltip.hidePopup();
   }


   this.newGeneric = function(Box){
      Box.setAttribute("class", "ttBody");
      var topBox = document.createElement("vbox");
      Box.appendChild(topBox);


      ////////////////////////////////////////////
      var l = new oXUL.Label(topBox, "Notice: Currently there is no Internet connectivity.");
      l.setClass("ttBold");
      l.Make();

      XULSimple.Shim(topBox, 10, 10);
      XULSimple.Label(topBox, "The 1-ClickWeather extension");
      XULSimple.Label(topBox, "cannot be configured without Internet connectivity.");

      XULSimple.Shim(topBox, 10, 10);

      XULSimple.Label(topBox, "Once Internet connectivity has been restored, restart the")
      XULSimple.Label(topBox, "FireFox browser.  You will then be presented with the configuration");
      XULSimple.Label(topBox, "screens for the 1-ClickWeather extension.");


      ////////////////////////////////////////////
      XULSimple.Shim(topBox, 10, 10);
      XULSimple.Label(topBox, "Thank you.");
      XULSimple.Shim(topBox, 20, 20);

   }


   this.newHeader = function(Box){
      Box.setAttribute("class", "ttBody");
      var topBox = document.createElement("vbox");
      Box.appendChild(topBox);
      XULSimple.Shim(topBox, 200, 10, "ttBody");

   }


   this.newFooter = function(Box){
      XULSimple.Shim(Box, 5, 5, "ttLogoBody");
      var logoBox = document.createElement("hbox");
//      logoBox.setAttribute("width", 40);
      Box.appendChild(logoBox);
      ////////////////////////////////////////////
//      XULSimple.Spacer(logoBox, 5);

      logoBox.setAttribute("class", "ttLogoBody");
      var i = new oXUL.iconByID(logoBox, "footerlogoleft").Make();
      XULSimple.Shim(logoBox, 180, 10);
      var i = new oXUL.iconByID(logoBox, "footerlogoright").Make();

   }

   this.locateTooltip = function(){
      try{
         var newXY = Array();
         var xy = ToolbarContainers['Day4'].getScreenXY();

         newXY[0] = xy[0] - this.Box.width;
         if(xy[1] < this.Box.height){
            newXY[1] = xy[1];
         }else{
            newXY[1] = xy[1] - this.Box.height;
         }
        
         return(newXY);
      }catch(e){ alert("err: " + e); }

      return(Array(-1, -1));
   }
}
